<template>
    <div id="waitForOtherSelection" class="container center text-center">
        <h2>Wait for other selection</h2>
        <table class="text-center center">
            <tr>
                <td>
                    <Hint v-bind:roundId="roundId"></Hint>
                </td>
                <td>
                    <ChosenCard v-bind:chosenCardId=chosenCardId></ChosenCard>
                </td>
                <td>
                    <Points></Points>
                </td>
            </tr>
        </table>
        <br />
        <RemainingCards v-bind:playerId="playerId"></RemainingCards>
    </div>
</template>

<script>
    import axios from 'axios';
    import RemainingCards from './RemainingCards.vue';
    import ChosenCard from './ChosenCard.vue';
    import Hint from './Hint.vue';
    import Points from './Points';
    export default {
        name: 'waitForOtherSelection',
        components: {
            RemainingCards,
            Hint,
            ChosenCard,
            Points
        },
        data: function () {
            return {
                playerId: this.$route.params.playerId,
                roundId: this.$route.params.roundId,
                chosenCardId: this.$route.params.cardId,
                gameId: this.$route.params.gamedId,
                areAllSelected: false,
                polling: null,
                roundSelectedCardsParams: null
            }
        },
        methods: {
            checkIfAllCardsAlreadySelected() {
                this.polling = setInterval(() => {
                    axios.get("https://localhost:44361/api/round/" + this.roundId + "/roundCardsSelected")
                        .then(response => this.areAllSelected = response.data);
                    if (this.areAllSelected) {
                        this.$router.push({ name: 'roundSelectedCards', params: this.defineParams() });
                    }
                }, 3000);
            },
            defineParams() {
                return {
                    playerId: this.$route.params.playerId,
                    gameId: this.$route.params.gameId,
                    roundId: this.$route.params.roundId,
                    cardId: this.$route.params.cardId
                }
            }
        },
        beforeDestroy() {
            clearInterval(this.polling);
        },
        created: function () {
            this.checkIfAllCardsAlreadySelected();
        }
    }
</script>

<style scoped>
    .center {
  margin-left: auto;
  margin-right: auto;
}
     td {
        padding: 20px;
    }
</style>